.nolist
include \masm32\include\masm32rt.inc
include \masm32\macros\ucmacros.asm
include \masm32\macros\timers.asm
.686

StrLenW PROTO:DWORD
ucLen1 PROTO:DWORD
ucLen2 PROTO:DWORD
AzmtStrLenW PROTO :DWORD
ucLenScasW PROTO :DWORD
ucsLen PROTO :DWORD
lenUC0 PROTO :DWORD
lenUC1 PROTO :DWORD
lenUC2 PROTO :DWORD
lenUC3 PROTO :DWORD
lenUC4 PROTO :DWORD
lenUC5 PROTO :DWORD
lenUC6 PROTO :DWORD

LOOP_COUNT equ 1000000		; ******** CONSOLE Assembly ************

uclen MACRO arg
	or eax, -1
	mov edx, arg
@@:	inc eax
	cmp word ptr [edx+2*eax], 0
	jne @B
ENDM

.data
	WSTR ws, "my other brother darryl my other brother darryl my other brother darryl my other brother darryl xxxx"

.code
start:
    invoke crt_printf, chr$("%S%c"),ADDR ws,10, 10
    
    print "  LENGTHOF: ", 9
    print ustr$(LENGTHOF ws),13,10				; ***************** why such a low value? *****************
    print "  SIZEOF:    ", 9
    print ustr$(SIZEOF ws),13,10, 10

    print "ucLenScasW retval: ", 9
    invoke ucLenScasW, ADDR ws
    print ustr$(eax), ", size="
    mov eax, offset LucLenScasW-ucLenScasW
    print str$(eax), 13, 10

    print "lstrlenW return value: ", 9
    invoke lstrlenW, ADDR ws
    print ustr$(eax), ", size=0 (kernel32)", 13,10

    print "Masm32 ucLen retval: ", 9
    invoke ucLen, ADDR ws
    print ustr$(eax), ", size="
    mov eax, offset LucLen1-ucLen1
    print str$(eax), 13, 10

    print "uclen MACRO retval: ", 9
uclIn:
    uclen offset ws
uclOut:
    print ustr$(eax), ", size="
    mov eax, offset uclOut-uclIn
    print str$(eax), 13, 10

    print "ucsLen return value: ", 9
    invoke ucsLen, ADDR ws
    print ustr$(eax), ", size="
    mov eax, offset LucsLen-ucsLen
    print str$(eax), 13, 10

    print "lenUC1 return value: ", 9
    invoke lenUC1, ADDR ws
    print ustr$(eax), ", size="
    mov eax, offset LlenUC-lenUC1
    print str$(eax), 13, 10

    print "StrLenW return value: ", 9
    invoke StrLenW, ADDR ws
    print ustr$(eax), ", size="
    mov eax, offset LucsLen-ucsLen
    print str$(eax), 13, 10

    print "AzmtStr return value: ", 9
    invoke AzmtStrLenW, ADDR ws
    print ustr$(eax), ", size="
    mov eax, offset LAzmtStrLenW-AzmtStrLenW
    print str$(eax), 13, 10, 10

	invoke Sleep, 200
REPEAT 3
	if 0
	print "ucLenScasW: ", 9
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke ucLenScasW, ADDR ws
	mov edi, eax
	counter_end
	print ustr$(eax)," cycles",13,10

	print "lstrlenW: ", 9
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke lstrlenW, ADDR ws
	counter_end
	print ustr$(eax)," cycles",13,10

	print "Masm32 ucLen: ", 9
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	invoke ucLen, addr ws
	counter_end
	print ustr$(eax)," cycles",13,10 

	print "uclen MACRO: ", 9
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		uclen offset ws
	counter_end
	print ustr$(eax)," cycles",13,10
	endif
	print "DoomyD ucsLen:", 9
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke ucsLen, ADDR ws
	counter_end
	print ustr$(eax)," cycles",13,10 	; ******************************

	print "lenUC0:    ", 9
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke lenUC0, ADDR ws
	counter_end
	print ustr$(eax)," cycles",13,10 

	print "lenUC1:    ", 9
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke lenUC1, ADDR ws
	counter_end
	print ustr$(eax)," cycles",13,10 

	print "lenUC2:    ", 9
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke lenUC2, ADDR ws
	counter_end
	print ustr$(eax)," cycles",13,10 

	print "lenUC3:    ", 9
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke lenUC3, ADDR ws
	counter_end
	print ustr$(eax)," cycles",13,10 

	print "lenUC4:    ", 9
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke lenUC4, ADDR ws
	counter_end
	print ustr$(eax)," cycles",13,10 

	print "lenUC5:    ", 9
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke lenUC5, ADDR ws
	counter_end
	print ustr$(eax)," cycles",13,10 

	print "lenUC6:    ", 9
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke lenUC6, ADDR ws
	counter_end
	print ustr$(eax)," cycles",13,10

;	print "StrLenW: ", 9
;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		invoke StrLenW, ADDR ws
;	counter_end
;	print ustr$(eax)," cycles",13,10 	; ******************************
 
	print "AzmtStrLenW: ", 9
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke AzmtStrLenW, ADDR ws
	counter_end
	print ustr$(eax)," cycles",13,10,10
ENDM

    inkey "Hit any key to get outta here...", 13, 10
    exit

; 

OPTION PROLOGUE:NONE	; for all algos 
OPTION EPILOGUE:NONE 

align 16
;
; Return characters length of lpszStr excluding zero-terminated char
;
StrLenW proc public p_lpszStr:dword

   mov eax, [esp+4]
   sub eax, 8
@@:
   add eax, 8
   cmp word ptr [eax], 0
   je Add0
   cmp word ptr [eax+2], 0
   je Add1
   cmp word ptr [eax+4], 0
   je Add2
   cmp word ptr [eax+6], 0
   jne @B

   sub eax, [esp+4]
   shr eax, 1
   add eax, 3
   ret 4

Add2:
   sub eax, [esp+4]
   shr eax, 1
   add eax, 2
   ret 4

Add1:
   sub eax, [esp+4]
   shr eax, 1
   add eax, 1
   ret 4

Add0:
   sub eax, [esp+4]
   shr eax, 1
   ret 4

StrLenW endp
LStrLenW:

align 4	; doesn't help...	
ucLenScasW proc src:DWORD
	push edi
	mov edi, [esp+8]
	or ecx, -1
	xor eax, eax
	repne scasw
	not ecx
	mov eax,ecx
	dec eax
	pop edi
	ret 4
ucLenScasW endp
LucLenScasW:

even
ucsLen   proc   buf
   mov   eax,[esp+4]
   .repeat
      REPEAT 3
      mov    ecx,[eax]
      add    eax,4
      test   ecx, 00000FFFFh
      jz     _EVEN_
      test   ecx, 0FFFF0000h
      jz     _ODD_
      ENDM
      mov    ecx,[eax]
      add    eax,4
      test   ecx,00000FFFFh
      jz     _EVEN_
      test   ecx,0FFFF0000h
   .until zero?
   _ODD_:
   add   eax,2
   _EVEN_:
   sub   eax,4
   sub   eax,[esp+4]
   shr   eax,1
   retn  4
ucsLen endp
LucsLen:

align 2
lenUC0 proc pStr					; ***************** why no improvement for unrolling? *****************
	mov eax, [esp+4]
	.Repeat
		REPEAT 0		; 0=155, 1=137, 2=150, 3=141, 4=152 cycles
		  test dword ptr [eax], 00000FFFFh		; one unroll yields best result
		  je j0
		  test dword ptr [eax], 0FFFF0000h
		  je j2
		  add eax, 4
		ENDM
		test dword ptr [eax], 00000FFFFh
		je j0
		test dword ptr [eax], 0FFFF0000h
		lea eax, [eax+4]				; keep the zero flag
	.Until Zero?
	if 1
	  sub eax, 4			; equally fast and shorter
	else
	  sub eax, [esp+4]	; reverse order and
	  sub eax, 2			; lose 18 cycles...!
	  shr eax, 1
	  retn 4
	endif
j2:	add eax, 2
j0:	sub eax, [esp+4]
	shr eax, 1
	retn 4
lenUC0 endp

align 2
lenUC1 proc pStr					; ***************** why no improvement for unrolling? *****************
	mov eax, [esp+4]
	.Repeat
		REPEAT 1		; 0=155, 1=137, 2=150, 3=141, 4=152 cycles
		  test dword ptr [eax], 00000FFFFh		; one unroll yields best result
		  je j0
		  test dword ptr [eax], 0FFFF0000h
		  je j2
		  add eax, 4
		ENDM
		test dword ptr [eax], 00000FFFFh
		je j0
		test dword ptr [eax], 0FFFF0000h
		lea eax, [eax+4]				; keep the zero flag
	.Until Zero?
	if 1
	  sub eax, 4			; equally fast and shorter
	else
	  sub eax, [esp+4]	; reverse order and
	  sub eax, 2			; lose 18 cycles...!
	  shr eax, 1
	  retn 4
	endif
j2:	add eax, 2
j0:	sub eax, [esp+4]
	shr eax, 1
	retn 4
lenUC1 endp
LlenUC:

align 2
lenUC2 proc pStr					; ***************** why no improvement for unrolling? *****************
	mov eax, [esp+4]
	.Repeat
		REPEAT 2		; 0=155, 1=137, 2=150, 3=141, 4=152 cycles
		  test dword ptr [eax], 00000FFFFh		; one unroll yields best result
		  je j0
		  test dword ptr [eax], 0FFFF0000h
		  je j2
		  add eax, 4
		ENDM
		test dword ptr [eax], 00000FFFFh
		je j0
		test dword ptr [eax], 0FFFF0000h
		lea eax, [eax+4]				; keep the zero flag
	.Until Zero?
	if 1
	  sub eax, 4			; equally fast and shorter
	else
	  sub eax, [esp+4]	; reverse order and
	  sub eax, 2			; lose 18 cycles...!
	  shr eax, 1
	  retn 4
	endif
j2:	add eax, 2
j0:	sub eax, [esp+4]
	shr eax, 1
	retn 4
lenUC2 endp
align 2
lenUC3 proc pStr					; ***************** why no improvement for unrolling? *****************
	mov eax, [esp+4]
	.Repeat
		REPEAT 3		; 0=155, 1=137, 2=150, 3=141, 4=152 cycles
		  test dword ptr [eax], 00000FFFFh		; one unroll yields best result
		  je j0
		  test dword ptr [eax], 0FFFF0000h
		  je j2
		  add eax, 4
		ENDM
		test dword ptr [eax], 00000FFFFh
		je j0
		test dword ptr [eax], 0FFFF0000h
		lea eax, [eax+4]				; keep the zero flag
	.Until Zero?
	if 1
	  sub eax, 4			; equally fast and shorter
	else
	  sub eax, [esp+4]	; reverse order and
	  sub eax, 2			; lose 18 cycles...!
	  shr eax, 1
	  retn 4
	endif
j2:	add eax, 2
j0:	sub eax, [esp+4]
	shr eax, 1
	retn 4
lenUC3 endp
align 2
lenUC4 proc pStr					; ***************** why no improvement for unrolling? *****************
	mov eax, [esp+4]
	.Repeat
		REPEAT 4		; 0=155, 1=137, 2=150, 3=141, 4=152 cycles
		  test dword ptr [eax], 00000FFFFh		; one unroll yields best result
		  je j0
		  test dword ptr [eax], 0FFFF0000h
		  je j2
		  add eax, 4
		ENDM
		test dword ptr [eax], 00000FFFFh
		je j0
		test dword ptr [eax], 0FFFF0000h
		lea eax, [eax+4]				; keep the zero flag
	.Until Zero?
	if 1
	  sub eax, 4			; equally fast and shorter
	else
	  sub eax, [esp+4]	; reverse order and
	  sub eax, 2			; lose 18 cycles...!
	  shr eax, 1
	  retn 4
	endif
j2:	add eax, 2
j0:	sub eax, [esp+4]
	shr eax, 1
	retn 4
lenUC4 endp
align 2
lenUC5 proc pStr					; ***************** why no improvement for unrolling? *****************
	mov eax, [esp+4]
	.Repeat
		REPEAT 5		; 0=155, 1=137, 2=150, 3=141, 4=152 cycles
		  test dword ptr [eax], 00000FFFFh		; one unroll yields best result
		  je j0
		  test dword ptr [eax], 0FFFF0000h
		  je j2
		  add eax, 4
		ENDM
		test dword ptr [eax], 00000FFFFh
		je j0
		test dword ptr [eax], 0FFFF0000h
		lea eax, [eax+4]				; keep the zero flag
	.Until Zero?
	if 1
	  sub eax, 4			; equally fast and shorter
	else
	  sub eax, [esp+4]	; reverse order and
	  sub eax, 2			; lose 18 cycles...!
	  shr eax, 1
	  retn 4
	endif
j2:	add eax, 2
j0:	sub eax, [esp+4]
	shr eax, 1
	retn 4
lenUC5 endp
align 2
lenUC6 proc pStr					; ***************** why no improvement for unrolling? *****************
	mov eax, [esp+4]
	.Repeat
		REPEAT 6		; 0=155, 1=137, 2=150, 3=141, 4=152 cycles
		  test dword ptr [eax], 00000FFFFh		; one unroll yields best result
		  je j0
		  test dword ptr [eax], 0FFFF0000h
		  je j2
		  add eax, 4
		ENDM
		test dword ptr [eax], 00000FFFFh
		je j0
		test dword ptr [eax], 0FFFF0000h
		lea eax, [eax+4]				; keep the zero flag
	.Until Zero?
	if 1
	  sub eax, 4			; equally fast and shorter
	else
	  sub eax, [esp+4]	; reverse order and
	  sub eax, 2			; lose 18 cycles...!
	  shr eax, 1
	  retn 4
	endif
j2:	add eax, 2
j0:	sub eax, [esp+4]
	shr eax, 1
	retn 4
lenUC6 endp


align 16
DB 8 DUP (90h)

; Returns the string length in EAX and pointer in EDX
; p_lpszStr = Pointer to the string

AzmtStrLenW PROC p_lpszStr:DWORD

    mov edx, dword ptr [esp+4]
    xor eax, eax
    xor ecx, ecx

@@:
    cmp word ptr [edx+eax], 0
    je @0
    cmp word ptr [edx+eax+2], cx
    je @1
    cmp word ptr [edx+eax+4], cx
    je @2
    cmp word ptr [edx+eax+6], cx
    je @3
    cmp word ptr [edx+eax+8], cx
    je @4
    cmp word ptr [edx+eax+10], cx
    je @5
    cmp word ptr [edx+eax+12], cx
    je @6
    cmp word ptr [edx+eax+14], cx
    je @7
    cmp word ptr [edx+eax+16], cx
    je @8
    cmp word ptr [edx+eax+18], cx
    je @9
    cmp word ptr [edx+eax+20], cx
    je @10
    cmp word ptr [edx+eax+22], cx
    je @11
    cmp word ptr [edx+eax+24], cx
    je @12
    cmp word ptr [edx+eax+26], cx
    je @13
    cmp word ptr [edx+eax+28], cx
    je @14
    add eax, 32
    cmp word ptr [edx+eax-2], cx
    jne @B

    sub eax, 2

@0:
    shr eax, 1
    ret 4

@1:
    add eax, 2
    shr eax, 1
    ret 4

@2:
    add eax, 4
    shr eax, 1
    ret 4

@3:
    add eax, 6
    shr eax, 1
    ret 4

@4:
    add eax, 8
    shr eax, 1
    ret 4

@5:
    add eax, 10
    shr eax, 1
    ret 4

@6:
    add eax, 12
    shr eax, 1
    ret 4

@7:
    add eax, 14
    shr eax, 1
    ret 4

@8:
    add eax, 16
    shr eax, 1
    ret 4

@9:
    add eax, 18
    shr eax, 1
    ret 4

@10:
    add eax, 20
    shr eax, 1
    ret 4

@11:
    add eax, 22
    shr eax, 1
    ret 4

@12:
    add eax, 24
    shr eax, 1
    ret 4

@13:
    add eax, 26
    shr eax, 1
    ret 4

@14:
    add eax, 28
    shr eax, 1
    ret 4

AzmtStrLenW ENDP
LAzmtStrLenW:

ucLen1 proc buffer					; original Masm32 lib version
	mov ecx, dword ptr [esp+4]
	mov edx, -2
	mov eax, -1
@@:	add edx, 2
	add eax, 1
	cmp word ptr [ecx+edx], 0
	jne @B
	retn 4
ucLen1 endp
LucLen1:

ucLen2 proc buffer	; as macro??
	or eax, -1
	mov edx, dword ptr [esp+4]
@@:	inc eax
	cmp word ptr [edx+2*eax], 0
	jne @B
	retn 4
ucLen2 endp
LucLen2:

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

; 

end start

OPT_Assembler	ml
OPT_Tmp2Asm	1
OPT_Wait	0
